package ufida.fasterxml.jackson.databind.deser.extend;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import ufida.fasterxml.jackson.core.JsonParser;
import ufida.fasterxml.jackson.core.JsonProcessingException;
import ufida.fasterxml.jackson.core.JsonToken;
import ufida.fasterxml.jackson.databind.DeserializationContext;
import ufida.fasterxml.jackson.databind.DeserializationFeature;
import ufida.fasterxml.jackson.databind.JsonDeserializer;
import ufida.fasterxml.jackson.databind.jsontype.TypeDeserializer;

public class CustomArrayDeserializer extends JsonDeserializer<List>{  
	  
	 protected JsonDeserializer<List> _valueDeserializer;
	 
	 protected  TypeDeserializer _valueTypeDeserializer;
	
    @Override  
    public List deserialize(JsonParser jsonParser, DeserializationContext ctxt)  
            throws IOException, JsonProcessingException {  
       
//    	if(jsonParser.getCurrentToken() == JsonToken.START_ARRAY) {
//    		return null;
//    	}
////    	JsonToken t;
////        List result = new ArrayList();
    	
//    	else if(jsonParser.getCurrentToken() == JsonToken.START_OBJECT) {
//    		//JsonDeserializer<Object> deser = _findRootDeserializer(ctxt, valueType);
//    		List results = new ArrayList();
//    		return  handleNonArray(jsonParser,ctxt, results);
//    	}else {
//    		return null;
//    	}
    	
        JsonToken t;
        List result = new ArrayList();
        //jsonParser.getText();
        //if(jsonParser.getCurrentToken() == JsonToken.START_OBJECT){
 
	     //   while ((t = jsonParser.nextToken()) != JsonToken.END_OBJECT) {
	        	//jsonParser.nextToken();
        if(jsonParser.getCurrentToken() == JsonToken.VALUE_STRING)
	         result.add((jsonParser.getCurrentToken() == JsonToken.VALUE_NULL) ? null : jsonParser.getText());
	       //}
	     return result;
       // }else 
         //  return null;
    }  
    
    private  List handleNonArray(JsonParser jp, DeserializationContext ctxt,
            List result)
        throws IOException, JsonProcessingException
    {
        // [JACKSON-526]: implicit arrays from single values?
        if (!ctxt.isEnabled(DeserializationFeature.ACCEPT_SINGLE_VALUE_AS_ARRAY)) {
            //throw ctxt.mappingException(_collectionType.getRawClass());
        }
        JsonDeserializer<List> valueDes = _valueDeserializer;
        final TypeDeserializer typeDeser = _valueTypeDeserializer;
        JsonToken t = jp.getCurrentToken();

        Object value;
        
        if (t == JsonToken.VALUE_NULL) {
            value = null;
        } else if (typeDeser == null) {
            value = valueDes.deserialize(jp, ctxt);
        } else {
            value = valueDes.deserializeWithType(jp, ctxt, typeDeser);
        }
        result.add(value);
        return result;
    }
    
    private List deserializeUsingCustom(JsonParser jp, DeserializationContext ctxt,
            List result, final JsonDeserializer<List> deser)
        throws IOException, JsonProcessingException
    {
        JsonToken t;
        while ((t = jp.nextToken()) != JsonToken.END_ARRAY) {
            Object value;

            if (t == JsonToken.VALUE_NULL) {
                value = null;
            } else {
                value = deser.deserialize(jp, ctxt);
            }
            result.add(value);
        }
        return result;
    }
    
    
}  
